/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIAbAddressCollecter.idl
 */

#ifndef __gen_nsIAbAddressCollecter_h__
#define __gen_nsIAbAddressCollecter_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIAbCard; /* forward declaration */


/* starting interface:    nsIAbAddressCollecter */
#define NS_IABADDRESSCOLLECTER_IID_STR "759cd643-e96b-4f31-883d-d9cf3d14f7c2"

#define NS_IABADDRESSCOLLECTER_IID \
  {0x759cd643, 0xe96b, 0x4f31, \
    { 0x88, 0x3d, 0xd9, 0xcf, 0x3d, 0x14, 0xf7, 0xc2 }}

/**
 * nsIAbAddressCollecter is the interface to the address collecter service.
 * It will save and update the supplied addresses into the address book
 * specified by the "mail.collect_addressbook" pref.
 */
class NS_NO_VTABLE NS_SCRIPTABLE nsIAbAddressCollecter : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IABADDRESSCOLLECTER_IID)

  /**
   * Collects email addresses into the address book.
   * If a card already exists for the email, the first/last/display names
   * will be updated if they are supplied alongside the address.
   * If a card does not exist for the email it will be created if aCreateCard
   * is true.
   * 
   * @param  aAddresses  The list of emails (in standard header format)
   *                     to collect into the address book.
   * @param  aCreateCard Set to true if a card should be created if the
   *                     email address doesn't exist.
   * @param  aSendFormat The send format to save for the card. See
   *                     nsIAbPreferMailFormat for values. If updating a card
   *                     this value will only be changed if the current value
   *                     for the card is "unknown".
   */
  /* void collectAddress (in AUTF8String aAddresses, in boolean aCreateCard, in unsigned long aSendFormat); */
  NS_SCRIPTABLE NS_IMETHOD CollectAddress(const nsACString & aAddresses, PRBool aCreateCard, PRUint32 aSendFormat) = 0;

  /**
   * Get the first card with this name / value in the collected ab.
   */
  /* nsIAbCard getCardFromAttribute (in ACString aName, in ACString aValue); */
  NS_SCRIPTABLE NS_IMETHOD GetCardFromAttribute(const nsACString & aName, const nsACString & aValue, nsIAbCard **_retval) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIAbAddressCollecter, NS_IABADDRESSCOLLECTER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIABADDRESSCOLLECTER \
  NS_SCRIPTABLE NS_IMETHOD CollectAddress(const nsACString & aAddresses, PRBool aCreateCard, PRUint32 aSendFormat); \
  NS_SCRIPTABLE NS_IMETHOD GetCardFromAttribute(const nsACString & aName, const nsACString & aValue, nsIAbCard **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIABADDRESSCOLLECTER(_to) \
  NS_SCRIPTABLE NS_IMETHOD CollectAddress(const nsACString & aAddresses, PRBool aCreateCard, PRUint32 aSendFormat) { return _to CollectAddress(aAddresses, aCreateCard, aSendFormat); } \
  NS_SCRIPTABLE NS_IMETHOD GetCardFromAttribute(const nsACString & aName, const nsACString & aValue, nsIAbCard **_retval) { return _to GetCardFromAttribute(aName, aValue, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIABADDRESSCOLLECTER(_to) \
  NS_SCRIPTABLE NS_IMETHOD CollectAddress(const nsACString & aAddresses, PRBool aCreateCard, PRUint32 aSendFormat) { return !_to ? NS_ERROR_NULL_POINTER : _to->CollectAddress(aAddresses, aCreateCard, aSendFormat); } \
  NS_SCRIPTABLE NS_IMETHOD GetCardFromAttribute(const nsACString & aName, const nsACString & aValue, nsIAbCard **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCardFromAttribute(aName, aValue, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsAbAddressCollecter : public nsIAbAddressCollecter
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIABADDRESSCOLLECTER

  nsAbAddressCollecter();

private:
  ~nsAbAddressCollecter();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsAbAddressCollecter, nsIAbAddressCollecter)

nsAbAddressCollecter::nsAbAddressCollecter()
{
  /* member initializers and constructor code */
}

nsAbAddressCollecter::~nsAbAddressCollecter()
{
  /* destructor code */
}

/* void collectAddress (in AUTF8String aAddresses, in boolean aCreateCard, in unsigned long aSendFormat); */
NS_IMETHODIMP nsAbAddressCollecter::CollectAddress(const nsACString & aAddresses, PRBool aCreateCard, PRUint32 aSendFormat)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIAbCard getCardFromAttribute (in ACString aName, in ACString aValue); */
NS_IMETHODIMP nsAbAddressCollecter::GetCardFromAttribute(const nsACString & aName, const nsACString & aValue, nsIAbCard **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIAbAddressCollecter_h__ */
