/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIAddrDBListener.idl
 */

#ifndef __gen_nsIAddrDBListener_h__
#define __gen_nsIAddrDBListener_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIAbCard_h__
#include "nsIAbCard.h"
#endif

#ifndef __gen_nsIAbDirectory_h__
#include "nsIAbDirectory.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIAddrDBAnnouncer; /* forward declaration */


/* starting interface:    nsIAddrDBListener */
#define NS_IADDRDBLISTENER_IID_STR "5d7e5a7a-1ac9-46dc-abfd-758c98be26e9"

#define NS_IADDRDBLISTENER_IID \
  {0x5d7e5a7a, 0x1ac9, 0x46dc, \
    { 0xab, 0xfd, 0x75, 0x8c, 0x98, 0xbe, 0x26, 0xe9 }}

class NS_NO_VTABLE NS_SCRIPTABLE nsIAddrDBListener : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IADDRDBLISTENER_IID)

  /* void onCardAttribChange (in unsigned long abCode); */
  NS_SCRIPTABLE NS_IMETHOD OnCardAttribChange(PRUint32 abCode) = 0;

  /**
   * Handle the card entry change event.
   *
   * @param     aAbCode         The code to indicate the type of event
   *                            (see nsAddrDatabase.h AB_NOTIFY_CODE for values).
   * @param     aCard           The card entry on which the event occurred.
   * @param     aParent         The parent of card entry.
   *                            If set to null, the event can be ignored.
   *                            This happens during import & sync operations when
   *                            listeners of a database need not be notified about
   *                            card entry changes.
   */
  /* void onCardEntryChange (in unsigned long aAbCode, in nsIAbCard aCard, in nsIAbDirectory aParent); */
  NS_SCRIPTABLE NS_IMETHOD OnCardEntryChange(PRUint32 aAbCode, nsIAbCard *aCard, nsIAbDirectory *aParent) = 0;

  /* void onListEntryChange (in unsigned long abCode, in nsIAbDirectory list); */
  NS_SCRIPTABLE NS_IMETHOD OnListEntryChange(PRUint32 abCode, nsIAbDirectory *list) = 0;

  /* void onAnnouncerGoingAway (); */
  NS_SCRIPTABLE NS_IMETHOD OnAnnouncerGoingAway(void) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIAddrDBListener, NS_IADDRDBLISTENER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIADDRDBLISTENER \
  NS_SCRIPTABLE NS_IMETHOD OnCardAttribChange(PRUint32 abCode); \
  NS_SCRIPTABLE NS_IMETHOD OnCardEntryChange(PRUint32 aAbCode, nsIAbCard *aCard, nsIAbDirectory *aParent); \
  NS_SCRIPTABLE NS_IMETHOD OnListEntryChange(PRUint32 abCode, nsIAbDirectory *list); \
  NS_SCRIPTABLE NS_IMETHOD OnAnnouncerGoingAway(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIADDRDBLISTENER(_to) \
  NS_SCRIPTABLE NS_IMETHOD OnCardAttribChange(PRUint32 abCode) { return _to OnCardAttribChange(abCode); } \
  NS_SCRIPTABLE NS_IMETHOD OnCardEntryChange(PRUint32 aAbCode, nsIAbCard *aCard, nsIAbDirectory *aParent) { return _to OnCardEntryChange(aAbCode, aCard, aParent); } \
  NS_SCRIPTABLE NS_IMETHOD OnListEntryChange(PRUint32 abCode, nsIAbDirectory *list) { return _to OnListEntryChange(abCode, list); } \
  NS_SCRIPTABLE NS_IMETHOD OnAnnouncerGoingAway(void) { return _to OnAnnouncerGoingAway(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIADDRDBLISTENER(_to) \
  NS_SCRIPTABLE NS_IMETHOD OnCardAttribChange(PRUint32 abCode) { return !_to ? NS_ERROR_NULL_POINTER : _to->OnCardAttribChange(abCode); } \
  NS_SCRIPTABLE NS_IMETHOD OnCardEntryChange(PRUint32 aAbCode, nsIAbCard *aCard, nsIAbDirectory *aParent) { return !_to ? NS_ERROR_NULL_POINTER : _to->OnCardEntryChange(aAbCode, aCard, aParent); } \
  NS_SCRIPTABLE NS_IMETHOD OnListEntryChange(PRUint32 abCode, nsIAbDirectory *list) { return !_to ? NS_ERROR_NULL_POINTER : _to->OnListEntryChange(abCode, list); } \
  NS_SCRIPTABLE NS_IMETHOD OnAnnouncerGoingAway(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->OnAnnouncerGoingAway(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsAddrDBListener : public nsIAddrDBListener
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIADDRDBLISTENER

  nsAddrDBListener();

private:
  ~nsAddrDBListener();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsAddrDBListener, nsIAddrDBListener)

nsAddrDBListener::nsAddrDBListener()
{
  /* member initializers and constructor code */
}

nsAddrDBListener::~nsAddrDBListener()
{
  /* destructor code */
}

/* void onCardAttribChange (in unsigned long abCode); */
NS_IMETHODIMP nsAddrDBListener::OnCardAttribChange(PRUint32 abCode)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void onCardEntryChange (in unsigned long aAbCode, in nsIAbCard aCard, in nsIAbDirectory aParent); */
NS_IMETHODIMP nsAddrDBListener::OnCardEntryChange(PRUint32 aAbCode, nsIAbCard *aCard, nsIAbDirectory *aParent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void onListEntryChange (in unsigned long abCode, in nsIAbDirectory list); */
NS_IMETHODIMP nsAddrDBListener::OnListEntryChange(PRUint32 abCode, nsIAbDirectory *list)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void onAnnouncerGoingAway (); */
NS_IMETHODIMP nsAddrDBListener::OnAnnouncerGoingAway()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIAddrDBListener_h__ */
