/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIMimeConverter.idl
 */

#ifndef __gen_nsIMimeConverter_h__
#define __gen_nsIMimeConverter_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
/* Opaque objects used by the encoder/decoder to store state. */
typedef struct MimeDecoderData MimeDecoderData;
typedef struct MimeEncoderData MimeEncoderData;
typedef nsresult (*PR_CALLBACK MimeConverterOutputCallback)
    (const char *buf, PRInt32 size, void *closure);

/* starting interface:    nsIMimeConverter */
#define NS_IMIMECONVERTER_IID_STR "879f3aeb-b48a-40c1-ae94-ed8f6ecdbc90"

#define NS_IMIMECONVERTER_IID \
  {0x879f3aeb, 0xb48a, 0x40c1, \
    { 0xae, 0x94, 0xed, 0x8f, 0x6e, 0xcd, 0xbc, 0x90 }}

/**
 * Encode/decode mail headers (via libmime).
 */
class NS_NO_VTABLE NS_SCRIPTABLE nsIMimeConverter : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IMIMECONVERTER_IID)

  /**
   * Suggested byte length limit for use when calling
   * encodeMimePartIIStr(_UTF8).
   */
  enum { MIME_ENCODED_WORD_SIZE = 72 };

  enum { MAX_CHARSET_NAME_LENGTH = 64 };

  /**
   * Encode an ASCII string into RFC2047 form, but don't use this...
   * use encodeMimePartIIStr_UTF8 for scripting purposes.
   * (The header argument could easily contain non-ASCII characters.)
   *
   * All this routine does is convert header to unicode, then call the
   * UTF8 version anyways.
   */
  /* string encodeMimePartIIStr (in string header, in boolean structured, in string mailCharset, in long fieldnamelen, in long encodedWordSize); */
  NS_SCRIPTABLE NS_IMETHOD EncodeMimePartIIStr(const char *header, PRBool structured, const char *mailCharset, PRInt32 fieldnamelen, PRInt32 encodedWordSize, char **_retval) = 0;

  /**
   * Encode a UTF-8 CString into RFC 2047 form ("=?" charset "?" encoding "?"
   * encoded-text "?=", where encoding is either "B" for BASE64 (RFC 2045) or
   * "Q" for quoted-printable-ish (RFC 2045)).
   *
   * @param header UTF-8 header to encode.
   * @param structured Is the header's field-body a "structured" field?
   *     (Encoded words are only allowed in comment/phrase portions of
   *     structured field bodies.)
   * @param mailCharset Charset name to convert (as an ASCII C string).
   * @param fieldnamelen Header field name lengt (ex: "From: " = 6)
   * @param encodedWordSize Byte length limit of the output, usually 72. (Use
   *     MIME_ENCODED_WORD_SIZE.)
   *
   * @return The encoded buffer (as a C string).
   */
  /* string encodeMimePartIIStr_UTF8 (in string header, in boolean structured, in string mailCharset, in long fieldnamelen, in long encodedWordSize); */
  NS_SCRIPTABLE NS_IMETHOD EncodeMimePartIIStr_UTF8(const char *header, PRBool structured, const char *mailCharset, PRInt32 fieldnamelen, PRInt32 encodedWordSize, char **_retval) = 0;

  /**
   * Decode a MIME header to UTF-8 if conversion is required.  Marked as
   * noscript because the return value may contain non-ASCII characters.
   *
   * @param header A (possibly encoded) header to decode.
   * @param default_charset The charset to apply to un-labeled non-UTF-8 data.
   * @param override_charset If true, default_charset is used instead of any
   *     charset labeling other than UTF-8.
   * @param eatContinuations If true, unfold headers.
   *
   * @return UTF-8 encoded value if conversion was required, nsnull if no
   *     conversion was required.
   */
  /* [noscript] string decodeMimeHeaderToCharPtr (in string header, in string default_charset, in boolean override_charset, in boolean eatContinuations); */
  NS_IMETHOD DecodeMimeHeaderToCharPtr(const char *header, const char *default_charset, PRBool override_charset, PRBool eatContinuations, char **_retval) = 0;

  /**
   * Decode a MIME header to UTF-16.
   *
   * @param header A (possibly encoded) header to decode.
   * @param default_charset The charset to apply to un-labeled non-UTF-8 data.
   * @param override_charset If true, default_charset is used instead of any
   *     charset labeling other than UTF-8.
   * @param eatContinuations If true, unfold headers.
   *
   * @return UTF-16 encoded value as an AString.
   */
  /* AString decodeMimeHeader (in string header, in string default_charset, in boolean override_charset, in boolean eatContinuations); */
  NS_SCRIPTABLE NS_IMETHOD DecodeMimeHeader(const char *header, const char *default_charset, PRBool override_charset, PRBool eatContinuations, nsAString & _retval) = 0;

  /* [noscript] MimeEncoderDataPtr B64EncoderInit (in MimeConverterOutputCallback output_fn, in voidPtr closure); */
  NS_IMETHOD B64EncoderInit(MimeConverterOutputCallback output_fn, void * closure, MimeEncoderData * *_retval) = 0;

  /* [noscript] MimeEncoderDataPtr QPEncoderInit (in MimeConverterOutputCallback output_fn, in voidPtr closure); */
  NS_IMETHOD QPEncoderInit(MimeConverterOutputCallback output_fn, void * closure, MimeEncoderData * *_retval) = 0;

  /* [noscript] MimeEncoderDataPtr UUEncoderInit (in string filename, in MimeConverterOutputCallback output_fn, in voidPtr closure); */
  NS_IMETHOD UUEncoderInit(const char *filename, MimeConverterOutputCallback output_fn, void * closure, MimeEncoderData * *_retval) = 0;

  /* [noscript] void EncoderDestroy (in MimeEncoderDataPtr data, in boolean abort_p); */
  NS_IMETHOD EncoderDestroy(MimeEncoderData * data, PRBool abort_p) = 0;

  /* [noscript] long EncoderWrite (in MimeEncoderDataPtr data, in string buffer, in long size); */
  NS_IMETHOD EncoderWrite(MimeEncoderData * data, const char *buffer, PRInt32 size, PRInt32 *_retval) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIMimeConverter, NS_IMIMECONVERTER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIMIMECONVERTER \
  NS_SCRIPTABLE NS_IMETHOD EncodeMimePartIIStr(const char *header, PRBool structured, const char *mailCharset, PRInt32 fieldnamelen, PRInt32 encodedWordSize, char **_retval); \
  NS_SCRIPTABLE NS_IMETHOD EncodeMimePartIIStr_UTF8(const char *header, PRBool structured, const char *mailCharset, PRInt32 fieldnamelen, PRInt32 encodedWordSize, char **_retval); \
  NS_IMETHOD DecodeMimeHeaderToCharPtr(const char *header, const char *default_charset, PRBool override_charset, PRBool eatContinuations, char **_retval); \
  NS_SCRIPTABLE NS_IMETHOD DecodeMimeHeader(const char *header, const char *default_charset, PRBool override_charset, PRBool eatContinuations, nsAString & _retval); \
  NS_IMETHOD B64EncoderInit(MimeConverterOutputCallback output_fn, void * closure, MimeEncoderData * *_retval); \
  NS_IMETHOD QPEncoderInit(MimeConverterOutputCallback output_fn, void * closure, MimeEncoderData * *_retval); \
  NS_IMETHOD UUEncoderInit(const char *filename, MimeConverterOutputCallback output_fn, void * closure, MimeEncoderData * *_retval); \
  NS_IMETHOD EncoderDestroy(MimeEncoderData * data, PRBool abort_p); \
  NS_IMETHOD EncoderWrite(MimeEncoderData * data, const char *buffer, PRInt32 size, PRInt32 *_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIMIMECONVERTER(_to) \
  NS_SCRIPTABLE NS_IMETHOD EncodeMimePartIIStr(const char *header, PRBool structured, const char *mailCharset, PRInt32 fieldnamelen, PRInt32 encodedWordSize, char **_retval) { return _to EncodeMimePartIIStr(header, structured, mailCharset, fieldnamelen, encodedWordSize, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD EncodeMimePartIIStr_UTF8(const char *header, PRBool structured, const char *mailCharset, PRInt32 fieldnamelen, PRInt32 encodedWordSize, char **_retval) { return _to EncodeMimePartIIStr_UTF8(header, structured, mailCharset, fieldnamelen, encodedWordSize, _retval); } \
  NS_IMETHOD DecodeMimeHeaderToCharPtr(const char *header, const char *default_charset, PRBool override_charset, PRBool eatContinuations, char **_retval) { return _to DecodeMimeHeaderToCharPtr(header, default_charset, override_charset, eatContinuations, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD DecodeMimeHeader(const char *header, const char *default_charset, PRBool override_charset, PRBool eatContinuations, nsAString & _retval) { return _to DecodeMimeHeader(header, default_charset, override_charset, eatContinuations, _retval); } \
  NS_IMETHOD B64EncoderInit(MimeConverterOutputCallback output_fn, void * closure, MimeEncoderData * *_retval) { return _to B64EncoderInit(output_fn, closure, _retval); } \
  NS_IMETHOD QPEncoderInit(MimeConverterOutputCallback output_fn, void * closure, MimeEncoderData * *_retval) { return _to QPEncoderInit(output_fn, closure, _retval); } \
  NS_IMETHOD UUEncoderInit(const char *filename, MimeConverterOutputCallback output_fn, void * closure, MimeEncoderData * *_retval) { return _to UUEncoderInit(filename, output_fn, closure, _retval); } \
  NS_IMETHOD EncoderDestroy(MimeEncoderData * data, PRBool abort_p) { return _to EncoderDestroy(data, abort_p); } \
  NS_IMETHOD EncoderWrite(MimeEncoderData * data, const char *buffer, PRInt32 size, PRInt32 *_retval) { return _to EncoderWrite(data, buffer, size, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIMIMECONVERTER(_to) \
  NS_SCRIPTABLE NS_IMETHOD EncodeMimePartIIStr(const char *header, PRBool structured, const char *mailCharset, PRInt32 fieldnamelen, PRInt32 encodedWordSize, char **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->EncodeMimePartIIStr(header, structured, mailCharset, fieldnamelen, encodedWordSize, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD EncodeMimePartIIStr_UTF8(const char *header, PRBool structured, const char *mailCharset, PRInt32 fieldnamelen, PRInt32 encodedWordSize, char **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->EncodeMimePartIIStr_UTF8(header, structured, mailCharset, fieldnamelen, encodedWordSize, _retval); } \
  NS_IMETHOD DecodeMimeHeaderToCharPtr(const char *header, const char *default_charset, PRBool override_charset, PRBool eatContinuations, char **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->DecodeMimeHeaderToCharPtr(header, default_charset, override_charset, eatContinuations, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD DecodeMimeHeader(const char *header, const char *default_charset, PRBool override_charset, PRBool eatContinuations, nsAString & _retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->DecodeMimeHeader(header, default_charset, override_charset, eatContinuations, _retval); } \
  NS_IMETHOD B64EncoderInit(MimeConverterOutputCallback output_fn, void * closure, MimeEncoderData * *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->B64EncoderInit(output_fn, closure, _retval); } \
  NS_IMETHOD QPEncoderInit(MimeConverterOutputCallback output_fn, void * closure, MimeEncoderData * *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->QPEncoderInit(output_fn, closure, _retval); } \
  NS_IMETHOD UUEncoderInit(const char *filename, MimeConverterOutputCallback output_fn, void * closure, MimeEncoderData * *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->UUEncoderInit(filename, output_fn, closure, _retval); } \
  NS_IMETHOD EncoderDestroy(MimeEncoderData * data, PRBool abort_p) { return !_to ? NS_ERROR_NULL_POINTER : _to->EncoderDestroy(data, abort_p); } \
  NS_IMETHOD EncoderWrite(MimeEncoderData * data, const char *buffer, PRInt32 size, PRInt32 *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->EncoderWrite(data, buffer, size, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsMimeConverter : public nsIMimeConverter
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIMIMECONVERTER

  nsMimeConverter();

private:
  ~nsMimeConverter();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsMimeConverter, nsIMimeConverter)

nsMimeConverter::nsMimeConverter()
{
  /* member initializers and constructor code */
}

nsMimeConverter::~nsMimeConverter()
{
  /* destructor code */
}

/* string encodeMimePartIIStr (in string header, in boolean structured, in string mailCharset, in long fieldnamelen, in long encodedWordSize); */
NS_IMETHODIMP nsMimeConverter::EncodeMimePartIIStr(const char *header, PRBool structured, const char *mailCharset, PRInt32 fieldnamelen, PRInt32 encodedWordSize, char **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* string encodeMimePartIIStr_UTF8 (in string header, in boolean structured, in string mailCharset, in long fieldnamelen, in long encodedWordSize); */
NS_IMETHODIMP nsMimeConverter::EncodeMimePartIIStr_UTF8(const char *header, PRBool structured, const char *mailCharset, PRInt32 fieldnamelen, PRInt32 encodedWordSize, char **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] string decodeMimeHeaderToCharPtr (in string header, in string default_charset, in boolean override_charset, in boolean eatContinuations); */
NS_IMETHODIMP nsMimeConverter::DecodeMimeHeaderToCharPtr(const char *header, const char *default_charset, PRBool override_charset, PRBool eatContinuations, char **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* AString decodeMimeHeader (in string header, in string default_charset, in boolean override_charset, in boolean eatContinuations); */
NS_IMETHODIMP nsMimeConverter::DecodeMimeHeader(const char *header, const char *default_charset, PRBool override_charset, PRBool eatContinuations, nsAString & _retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] MimeEncoderDataPtr B64EncoderInit (in MimeConverterOutputCallback output_fn, in voidPtr closure); */
NS_IMETHODIMP nsMimeConverter::B64EncoderInit(MimeConverterOutputCallback output_fn, void * closure, MimeEncoderData * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] MimeEncoderDataPtr QPEncoderInit (in MimeConverterOutputCallback output_fn, in voidPtr closure); */
NS_IMETHODIMP nsMimeConverter::QPEncoderInit(MimeConverterOutputCallback output_fn, void * closure, MimeEncoderData * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] MimeEncoderDataPtr UUEncoderInit (in string filename, in MimeConverterOutputCallback output_fn, in voidPtr closure); */
NS_IMETHODIMP nsMimeConverter::UUEncoderInit(const char *filename, MimeConverterOutputCallback output_fn, void * closure, MimeEncoderData * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] void EncoderDestroy (in MimeEncoderDataPtr data, in boolean abort_p); */
NS_IMETHODIMP nsMimeConverter::EncoderDestroy(MimeEncoderData * data, PRBool abort_p)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] long EncoderWrite (in MimeEncoderDataPtr data, in string buffer, in long size); */
NS_IMETHODIMP nsMimeConverter::EncoderWrite(MimeEncoderData * data, const char *buffer, PRInt32 size, PRInt32 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIMimeConverter_h__ */
