/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsMsgFolderFlags.idl
 */

#ifndef __gen_nsMsgFolderFlags_h__
#define __gen_nsMsgFolderFlags_h__
/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
/******* BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is
 * Netscape Communications Corporation.
 * Portions created by the Initial Developer are Copyright (C) 1998
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either of the GNU General Public License Version 2 or later (the "GPL"),
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
typedef PRUint32 nsMsgFolderFlagType;


/* starting interface:    nsMsgFolderFlags */
#define NS_MSGFOLDERFLAGS_IID_STR "e587ba31-3235-4133-ac5a-c1c1f4a5c981"

#define NS_MSGFOLDERFLAGS_IID \
  {0xe587ba31, 0x3235, 0x4133, \
    { 0xac, 0x5a, 0xc1, 0xc1, 0xf4, 0xa5, 0xc9, 0x81 }}

class NS_NO_VTABLE NS_SCRIPTABLE nsMsgFolderFlags {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_MSGFOLDERFLAGS_IID)

  /**
   * @name Folder Type Flags
   * These flags define the type of folder. Exactly one will be set.
   * @{
   */
  enum { Newsgroup = 1U };

  enum { NewsHost = 2U };

  enum { Mail = 4U };

  /** @} */
/** Whether this is a directory: NewsHosts are always directories;
   *  NewsGroups can be directories if we are in ``show all groups'' mode;
   *  Mail folders will have this bit if they are really directories, not files.
   *  (Note that directories may have zero children.)
   */
  enum { Directory = 8U };

  /** Whether the children of this folder are currently hidden in the listing.
   *  This will only be present if the nsMsgFolderFlags::Directory bit is on.
   */
  enum { Elided = 16U };

  enum { Virtual = 32U };

  /** @name News Folder Flags
   *  These flags only occur in folders which have
   *  the nsMsgFolderFlags::Newsgroup bit set, and do
   *  not have the nsMsgFolderFlags::Directory or
   *  nsMsgFolderFlags::Elided bits set.
   *  @{
   */
  enum { Subscribed = 64U };

  enum { Unused2 = 128U };

  /** @} */
/** @name Mail Folder Flags
   *  These flags only occur in folders which have
   *  the nsMsgFolderFlags::Mail bit set, and do
   *  not have the nsMsgFolderFlags::Directory or
   *  nsMsgFolderFlags::Elided bits set.
   *  @{
   */
  enum { Trash = 256U };

  enum { SentMail = 512U };

  enum { Drafts = 1024U };

  enum { Queue = 2048U };

  enum { Inbox = 4096U };

  enum { ImapBox = 8192U };

  enum { Unused3 = 16384U };

  enum { ProfileGroup = 32768U };

  enum { Unused4 = 65536U };

  enum { GotNew = 131072U };

  enum { ImapServer = 262144U };

  enum { ImapPersonal = 524288U };

  enum { ImapPublic = 1048576U };

  enum { ImapOtherUser = 2097152U };

  enum { Templates = 4194304U };

  enum { PersonalShared = 8388608U };

  enum { ImapNoselect = 16777216U };

  enum { CreatedOffline = 33554432U };

  enum { ImapNoinferiors = 67108864U };

  enum { Offline = 134217728U };

  enum { OfflineEvents = 268435456U };

  enum { CheckNew = 536870912U };

  enum { Junk = 1073741824U };

  enum { Favorite = 2147483648U };

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsMsgFolderFlags, NS_MSGFOLDERFLAGS_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSMSGFOLDERFLAGS \

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSMSGFOLDERFLAGS(_to) \

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSMSGFOLDERFLAGS(_to) \

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public nsMsgFolderFlags
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSMSGFOLDERFLAGS

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, nsMsgFolderFlags)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsMsgFolderFlags_h__ */
