/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsISmtpServer.idl
 */

#ifndef __gen_nsISmtpServer_h__
#define __gen_nsISmtpServer_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIAuthPrompt; /* forward declaration */


/* starting interface:    nsISmtpServer */
#define NS_ISMTPSERVER_IID_STR "1d449933-b0b7-4bbf-a8a4-cc4bb9b545c5"

#define NS_ISMTPSERVER_IID \
  {0x1d449933, 0xb0b7, 0x4bbf, \
    { 0xa8, 0xa4, 0xcc, 0x4b, 0xb9, 0xb5, 0x45, 0xc5 }}

/**
 * This interface represents a single SMTP Server. A SMTP server instance may be
 * created/obtained from nsIMsgAccountManager.
 *
 * Most of the attributes will set/get preferences from the main preferences
 * file.
 */
class NS_NO_VTABLE NS_SCRIPTABLE nsISmtpServer : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ISMTPSERVER_IID)

  /* attribute string key; */
  NS_SCRIPTABLE NS_IMETHOD GetKey(char * *aKey) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetKey(const char * aKey) = 0;

  /* attribute AUTF8String description; */
  NS_SCRIPTABLE NS_IMETHOD GetDescription(nsACString & aDescription) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetDescription(const nsACString & aDescription) = 0;

  /* attribute string hostname; */
  NS_SCRIPTABLE NS_IMETHOD GetHostname(char * *aHostname) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetHostname(const char * aHostname) = 0;

  /* attribute PRInt32 port; */
  NS_SCRIPTABLE NS_IMETHOD GetPort(PRInt32 *aPort) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetPort(PRInt32 aPort) = 0;

  /* attribute string username; */
  NS_SCRIPTABLE NS_IMETHOD GetUsername(char * *aUsername) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetUsername(const char * aUsername) = 0;

  /**
   * The password to access the server with (if required).
   *
   * @note this is stored within the server instance but not within preferences.
   * It can be specified/saved here to avoid prompting the user constantly for
   * the sending password.
   */
  /* attribute string password; */
  NS_SCRIPTABLE NS_IMETHOD GetPassword(char * *aPassword) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetPassword(const char * aPassword) = 0;

  /* readonly attribute string displayname; */
  NS_SCRIPTABLE NS_IMETHOD GetDisplayname(char * *aDisplayname) = 0;

  /**
   * Whether or not to use authentication for this server.
   * 0 = no authentication, 1 = use authentication.
   * Reflects the mail.smtpserver.*.auth_method pref (default has value 1).
   */
  /* attribute long authMethod; */
  NS_SCRIPTABLE NS_IMETHOD GetAuthMethod(PRInt32 *aAuthMethod) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetAuthMethod(PRInt32 aAuthMethod) = 0;

  /* attribute boolean useSecAuth; */
  NS_SCRIPTABLE NS_IMETHOD GetUseSecAuth(PRBool *aUseSecAuth) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetUseSecAuth(PRBool aUseSecAuth) = 0;

  /* attribute boolean trySecAuth; */
  NS_SCRIPTABLE NS_IMETHOD GetTrySecAuth(PRBool *aTrySecAuth) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetTrySecAuth(PRBool aTrySecAuth) = 0;

  /* attribute long trySSL; */
  NS_SCRIPTABLE NS_IMETHOD GetTrySSL(PRInt32 *aTrySSL) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetTrySSL(PRInt32 aTrySSL) = 0;

  /**
   * May contain an alternative argument to EHLO or HELO to provide to the
   * server. Reflects the value of the mail.smtpserver.*.hello_argument pref.
   * This is mainly useful where ISPs don't bother providing PTR records for
   * their servers and therefore users get an error on sending. See bug 244030
   * for more discussion.
   */
  /* readonly attribute string helloArgument; */
  NS_SCRIPTABLE NS_IMETHOD GetHelloArgument(char * *aHelloArgument) = 0;

  /* readonly attribute string serverURI; */
  NS_SCRIPTABLE NS_IMETHOD GetServerURI(char * *aServerURI) = 0;

  /**
   * Gets a password for this server, using a UI prompt if necessary.
   *
   * @param promptString  The string to prompt the user with when asking for
   *                      the password.
   * @param promptTitle   The title of the prompt.
   * @param netPrompt     An nsIAuthPrompt instance to use for the password
   *                      prompt.
   * @return              The password to use (may be null if no password was
   *                      obtained).
   */
  /* string getPasswordWithUI (in wstring promptString, in wstring promptTitle, in nsIAuthPrompt netPrompt); */
  NS_SCRIPTABLE NS_IMETHOD GetPasswordWithUI(const PRUnichar *promptString, const PRUnichar *promptTitle, nsIAuthPrompt *netPrompt, char **_retval) = 0;

  /**
   * Gets a username and password for this server, using a UI prompt if
   * necessary.
   *
   * @param promptString  The string to prompt the user with when asking for
   *                      the password.
   * @param promptTitle   The title of the prompt.
   * @param netPrompt     An nsIAuthPrompt instance to use for the password
   *                      prompt.
   * @param userid        The username to use (may be null if no password was
   *                      obtained).
   * @param password      The password to use (may be null if no password was
   *                      obtained).
   */
  /* void getUsernamePasswordWithUI (in wstring promptString, in wstring promptTitle, in nsIAuthPrompt netPrompt, out string userid, out string password); */
  NS_SCRIPTABLE NS_IMETHOD GetUsernamePasswordWithUI(const PRUnichar *promptString, const PRUnichar *promptTitle, nsIAuthPrompt *netPrompt, char **userid, char **password) = 0;

  /**
   * Calling this will *remove* the saved password for this server from the
   * password manager and from the stored value.
   */
  /* void forgetPassword (); */
  NS_SCRIPTABLE NS_IMETHOD ForgetPassword(void) = 0;

  /* void clearAllValues (); */
  NS_SCRIPTABLE NS_IMETHOD ClearAllValues(void) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsISmtpServer, NS_ISMTPSERVER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISMTPSERVER \
  NS_SCRIPTABLE NS_IMETHOD GetKey(char * *aKey); \
  NS_SCRIPTABLE NS_IMETHOD SetKey(const char * aKey); \
  NS_SCRIPTABLE NS_IMETHOD GetDescription(nsACString & aDescription); \
  NS_SCRIPTABLE NS_IMETHOD SetDescription(const nsACString & aDescription); \
  NS_SCRIPTABLE NS_IMETHOD GetHostname(char * *aHostname); \
  NS_SCRIPTABLE NS_IMETHOD SetHostname(const char * aHostname); \
  NS_SCRIPTABLE NS_IMETHOD GetPort(PRInt32 *aPort); \
  NS_SCRIPTABLE NS_IMETHOD SetPort(PRInt32 aPort); \
  NS_SCRIPTABLE NS_IMETHOD GetUsername(char * *aUsername); \
  NS_SCRIPTABLE NS_IMETHOD SetUsername(const char * aUsername); \
  NS_SCRIPTABLE NS_IMETHOD GetPassword(char * *aPassword); \
  NS_SCRIPTABLE NS_IMETHOD SetPassword(const char * aPassword); \
  NS_SCRIPTABLE NS_IMETHOD GetDisplayname(char * *aDisplayname); \
  NS_SCRIPTABLE NS_IMETHOD GetAuthMethod(PRInt32 *aAuthMethod); \
  NS_SCRIPTABLE NS_IMETHOD SetAuthMethod(PRInt32 aAuthMethod); \
  NS_SCRIPTABLE NS_IMETHOD GetUseSecAuth(PRBool *aUseSecAuth); \
  NS_SCRIPTABLE NS_IMETHOD SetUseSecAuth(PRBool aUseSecAuth); \
  NS_SCRIPTABLE NS_IMETHOD GetTrySecAuth(PRBool *aTrySecAuth); \
  NS_SCRIPTABLE NS_IMETHOD SetTrySecAuth(PRBool aTrySecAuth); \
  NS_SCRIPTABLE NS_IMETHOD GetTrySSL(PRInt32 *aTrySSL); \
  NS_SCRIPTABLE NS_IMETHOD SetTrySSL(PRInt32 aTrySSL); \
  NS_SCRIPTABLE NS_IMETHOD GetHelloArgument(char * *aHelloArgument); \
  NS_SCRIPTABLE NS_IMETHOD GetServerURI(char * *aServerURI); \
  NS_SCRIPTABLE NS_IMETHOD GetPasswordWithUI(const PRUnichar *promptString, const PRUnichar *promptTitle, nsIAuthPrompt *netPrompt, char **_retval); \
  NS_SCRIPTABLE NS_IMETHOD GetUsernamePasswordWithUI(const PRUnichar *promptString, const PRUnichar *promptTitle, nsIAuthPrompt *netPrompt, char **userid, char **password); \
  NS_SCRIPTABLE NS_IMETHOD ForgetPassword(void); \
  NS_SCRIPTABLE NS_IMETHOD ClearAllValues(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISMTPSERVER(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetKey(char * *aKey) { return _to GetKey(aKey); } \
  NS_SCRIPTABLE NS_IMETHOD SetKey(const char * aKey) { return _to SetKey(aKey); } \
  NS_SCRIPTABLE NS_IMETHOD GetDescription(nsACString & aDescription) { return _to GetDescription(aDescription); } \
  NS_SCRIPTABLE NS_IMETHOD SetDescription(const nsACString & aDescription) { return _to SetDescription(aDescription); } \
  NS_SCRIPTABLE NS_IMETHOD GetHostname(char * *aHostname) { return _to GetHostname(aHostname); } \
  NS_SCRIPTABLE NS_IMETHOD SetHostname(const char * aHostname) { return _to SetHostname(aHostname); } \
  NS_SCRIPTABLE NS_IMETHOD GetPort(PRInt32 *aPort) { return _to GetPort(aPort); } \
  NS_SCRIPTABLE NS_IMETHOD SetPort(PRInt32 aPort) { return _to SetPort(aPort); } \
  NS_SCRIPTABLE NS_IMETHOD GetUsername(char * *aUsername) { return _to GetUsername(aUsername); } \
  NS_SCRIPTABLE NS_IMETHOD SetUsername(const char * aUsername) { return _to SetUsername(aUsername); } \
  NS_SCRIPTABLE NS_IMETHOD GetPassword(char * *aPassword) { return _to GetPassword(aPassword); } \
  NS_SCRIPTABLE NS_IMETHOD SetPassword(const char * aPassword) { return _to SetPassword(aPassword); } \
  NS_SCRIPTABLE NS_IMETHOD GetDisplayname(char * *aDisplayname) { return _to GetDisplayname(aDisplayname); } \
  NS_SCRIPTABLE NS_IMETHOD GetAuthMethod(PRInt32 *aAuthMethod) { return _to GetAuthMethod(aAuthMethod); } \
  NS_SCRIPTABLE NS_IMETHOD SetAuthMethod(PRInt32 aAuthMethod) { return _to SetAuthMethod(aAuthMethod); } \
  NS_SCRIPTABLE NS_IMETHOD GetUseSecAuth(PRBool *aUseSecAuth) { return _to GetUseSecAuth(aUseSecAuth); } \
  NS_SCRIPTABLE NS_IMETHOD SetUseSecAuth(PRBool aUseSecAuth) { return _to SetUseSecAuth(aUseSecAuth); } \
  NS_SCRIPTABLE NS_IMETHOD GetTrySecAuth(PRBool *aTrySecAuth) { return _to GetTrySecAuth(aTrySecAuth); } \
  NS_SCRIPTABLE NS_IMETHOD SetTrySecAuth(PRBool aTrySecAuth) { return _to SetTrySecAuth(aTrySecAuth); } \
  NS_SCRIPTABLE NS_IMETHOD GetTrySSL(PRInt32 *aTrySSL) { return _to GetTrySSL(aTrySSL); } \
  NS_SCRIPTABLE NS_IMETHOD SetTrySSL(PRInt32 aTrySSL) { return _to SetTrySSL(aTrySSL); } \
  NS_SCRIPTABLE NS_IMETHOD GetHelloArgument(char * *aHelloArgument) { return _to GetHelloArgument(aHelloArgument); } \
  NS_SCRIPTABLE NS_IMETHOD GetServerURI(char * *aServerURI) { return _to GetServerURI(aServerURI); } \
  NS_SCRIPTABLE NS_IMETHOD GetPasswordWithUI(const PRUnichar *promptString, const PRUnichar *promptTitle, nsIAuthPrompt *netPrompt, char **_retval) { return _to GetPasswordWithUI(promptString, promptTitle, netPrompt, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD GetUsernamePasswordWithUI(const PRUnichar *promptString, const PRUnichar *promptTitle, nsIAuthPrompt *netPrompt, char **userid, char **password) { return _to GetUsernamePasswordWithUI(promptString, promptTitle, netPrompt, userid, password); } \
  NS_SCRIPTABLE NS_IMETHOD ForgetPassword(void) { return _to ForgetPassword(); } \
  NS_SCRIPTABLE NS_IMETHOD ClearAllValues(void) { return _to ClearAllValues(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSISMTPSERVER(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetKey(char * *aKey) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetKey(aKey); } \
  NS_SCRIPTABLE NS_IMETHOD SetKey(const char * aKey) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetKey(aKey); } \
  NS_SCRIPTABLE NS_IMETHOD GetDescription(nsACString & aDescription) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDescription(aDescription); } \
  NS_SCRIPTABLE NS_IMETHOD SetDescription(const nsACString & aDescription) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDescription(aDescription); } \
  NS_SCRIPTABLE NS_IMETHOD GetHostname(char * *aHostname) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetHostname(aHostname); } \
  NS_SCRIPTABLE NS_IMETHOD SetHostname(const char * aHostname) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetHostname(aHostname); } \
  NS_SCRIPTABLE NS_IMETHOD GetPort(PRInt32 *aPort) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPort(aPort); } \
  NS_SCRIPTABLE NS_IMETHOD SetPort(PRInt32 aPort) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetPort(aPort); } \
  NS_SCRIPTABLE NS_IMETHOD GetUsername(char * *aUsername) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetUsername(aUsername); } \
  NS_SCRIPTABLE NS_IMETHOD SetUsername(const char * aUsername) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetUsername(aUsername); } \
  NS_SCRIPTABLE NS_IMETHOD GetPassword(char * *aPassword) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPassword(aPassword); } \
  NS_SCRIPTABLE NS_IMETHOD SetPassword(const char * aPassword) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetPassword(aPassword); } \
  NS_SCRIPTABLE NS_IMETHOD GetDisplayname(char * *aDisplayname) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDisplayname(aDisplayname); } \
  NS_SCRIPTABLE NS_IMETHOD GetAuthMethod(PRInt32 *aAuthMethod) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAuthMethod(aAuthMethod); } \
  NS_SCRIPTABLE NS_IMETHOD SetAuthMethod(PRInt32 aAuthMethod) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetAuthMethod(aAuthMethod); } \
  NS_SCRIPTABLE NS_IMETHOD GetUseSecAuth(PRBool *aUseSecAuth) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetUseSecAuth(aUseSecAuth); } \
  NS_SCRIPTABLE NS_IMETHOD SetUseSecAuth(PRBool aUseSecAuth) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetUseSecAuth(aUseSecAuth); } \
  NS_SCRIPTABLE NS_IMETHOD GetTrySecAuth(PRBool *aTrySecAuth) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTrySecAuth(aTrySecAuth); } \
  NS_SCRIPTABLE NS_IMETHOD SetTrySecAuth(PRBool aTrySecAuth) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetTrySecAuth(aTrySecAuth); } \
  NS_SCRIPTABLE NS_IMETHOD GetTrySSL(PRInt32 *aTrySSL) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTrySSL(aTrySSL); } \
  NS_SCRIPTABLE NS_IMETHOD SetTrySSL(PRInt32 aTrySSL) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetTrySSL(aTrySSL); } \
  NS_SCRIPTABLE NS_IMETHOD GetHelloArgument(char * *aHelloArgument) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetHelloArgument(aHelloArgument); } \
  NS_SCRIPTABLE NS_IMETHOD GetServerURI(char * *aServerURI) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetServerURI(aServerURI); } \
  NS_SCRIPTABLE NS_IMETHOD GetPasswordWithUI(const PRUnichar *promptString, const PRUnichar *promptTitle, nsIAuthPrompt *netPrompt, char **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPasswordWithUI(promptString, promptTitle, netPrompt, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD GetUsernamePasswordWithUI(const PRUnichar *promptString, const PRUnichar *promptTitle, nsIAuthPrompt *netPrompt, char **userid, char **password) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetUsernamePasswordWithUI(promptString, promptTitle, netPrompt, userid, password); } \
  NS_SCRIPTABLE NS_IMETHOD ForgetPassword(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->ForgetPassword(); } \
  NS_SCRIPTABLE NS_IMETHOD ClearAllValues(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->ClearAllValues(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsSmtpServer : public nsISmtpServer
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSISMTPSERVER

  nsSmtpServer();

private:
  ~nsSmtpServer();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsSmtpServer, nsISmtpServer)

nsSmtpServer::nsSmtpServer()
{
  /* member initializers and constructor code */
}

nsSmtpServer::~nsSmtpServer()
{
  /* destructor code */
}

/* attribute string key; */
NS_IMETHODIMP nsSmtpServer::GetKey(char * *aKey)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsSmtpServer::SetKey(const char * aKey)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AUTF8String description; */
NS_IMETHODIMP nsSmtpServer::GetDescription(nsACString & aDescription)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsSmtpServer::SetDescription(const nsACString & aDescription)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute string hostname; */
NS_IMETHODIMP nsSmtpServer::GetHostname(char * *aHostname)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsSmtpServer::SetHostname(const char * aHostname)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute PRInt32 port; */
NS_IMETHODIMP nsSmtpServer::GetPort(PRInt32 *aPort)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsSmtpServer::SetPort(PRInt32 aPort)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute string username; */
NS_IMETHODIMP nsSmtpServer::GetUsername(char * *aUsername)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsSmtpServer::SetUsername(const char * aUsername)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute string password; */
NS_IMETHODIMP nsSmtpServer::GetPassword(char * *aPassword)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsSmtpServer::SetPassword(const char * aPassword)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute string displayname; */
NS_IMETHODIMP nsSmtpServer::GetDisplayname(char * *aDisplayname)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute long authMethod; */
NS_IMETHODIMP nsSmtpServer::GetAuthMethod(PRInt32 *aAuthMethod)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsSmtpServer::SetAuthMethod(PRInt32 aAuthMethod)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute boolean useSecAuth; */
NS_IMETHODIMP nsSmtpServer::GetUseSecAuth(PRBool *aUseSecAuth)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsSmtpServer::SetUseSecAuth(PRBool aUseSecAuth)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute boolean trySecAuth; */
NS_IMETHODIMP nsSmtpServer::GetTrySecAuth(PRBool *aTrySecAuth)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsSmtpServer::SetTrySecAuth(PRBool aTrySecAuth)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute long trySSL; */
NS_IMETHODIMP nsSmtpServer::GetTrySSL(PRInt32 *aTrySSL)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsSmtpServer::SetTrySSL(PRInt32 aTrySSL)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute string helloArgument; */
NS_IMETHODIMP nsSmtpServer::GetHelloArgument(char * *aHelloArgument)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute string serverURI; */
NS_IMETHODIMP nsSmtpServer::GetServerURI(char * *aServerURI)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* string getPasswordWithUI (in wstring promptString, in wstring promptTitle, in nsIAuthPrompt netPrompt); */
NS_IMETHODIMP nsSmtpServer::GetPasswordWithUI(const PRUnichar *promptString, const PRUnichar *promptTitle, nsIAuthPrompt *netPrompt, char **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getUsernamePasswordWithUI (in wstring promptString, in wstring promptTitle, in nsIAuthPrompt netPrompt, out string userid, out string password); */
NS_IMETHODIMP nsSmtpServer::GetUsernamePasswordWithUI(const PRUnichar *promptString, const PRUnichar *promptTitle, nsIAuthPrompt *netPrompt, char **userid, char **password)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void forgetPassword (); */
NS_IMETHODIMP nsSmtpServer::ForgetPassword()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void clearAllValues (); */
NS_IMETHODIMP nsSmtpServer::ClearAllValues()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsISmtpServer_h__ */
